# ;; -*- mode: org; coding: utf-8 -*-

#+TITLE: GNU G-Golf NEWS

#+BEGIN_COMMENT

Copyright (C) 2016 - 2024
Free Software Foundation, Inc.

This document is part of GNU G-Golf.

Copying and distribution of this file, with or without modification, are
permitted in any medium without royalty provided the copyright notice
and this notice are preserved.  This file is offered as-is, without any
warranty.

#+END_COMMENT


                G-Golf - History of user-visible changes
                ========================================

                   Please send G-Golf bug reports to
                           bug-g-golf@gnu.org


* Latest News

** Nov 2024

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc9 is released.

This is the ninth release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc9

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.


**** Examples

***** Adwaita Demo

The following Adwaita Demo pages have been added:

  AdwDemoPageAnimations

Note that this required quite a few changes compared to the upstream
demo, because in C, they can call gtk_widget_set_layout_manager, which
is not possible for (any) language bindings. Instead, language bindings
users must define a derived GtkLayoutManager class, and declare it as
the layout manager of the (derived GObject) class you are working
on. You may look at this (example) or the gtk-4 layout-manager and
layout-manager-2 examples to get inspired to write your first layout
manager derived class.

**** Bug fixing

***** gi-argument->scm

Working on the AdwDemoPageAnimations port to G-Golf revealed an
important (now fixed) bug in the gi-argument->scm procedure.

* Older News

** Oct 2024

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc8 is released.

This is the eighth release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc8

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.


**** New interfaces

  g-get-monotonic-time

**** Examples

***** Gtk-4

The following Gtk-4 demo have been added:

  Shortcuts
  Layout Manager (transformation)

All demo scripts have been renamed (no .scm extension).

***** Adwaita Demo

The Adwaita demo has been reviewed, and is now up-to-date with upstream
version 1.6.0 (except for the animation page, which still is missing in
G-Golf).

The following Adwaita Demo pages have been added:

  AdwDemoPageBottomSheets
  AdwDemoPageMultiLayout
  AdwDemoPageSpinner

The hello-world demo has been renamed (no .scm extension).

**** Bug fixing

***** string-replace-all

Snarfed from guile-3.0 (ice-9 string-fun).

Not exactly a bug, but as reported by Greg Troxel (thanks),
string-replace-substring isn't available in earlier versions of guile -
though we invite every g-golf users to use guile-3.0, when available,
there is also no reason why g-golf could not be built and used against
earlier versions of guile.

** Sep 2024

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc7 is released.

This is the seventh release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc7

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** Fixing the 0.8.0-rc6 release tarball malformed issue

This release merely fixes a missing examples/gtk-4/Makefile.am
(sub)target entry, so the tarball also distributes the newly added
examples/gtk-4/demos/*.scm files.

** Sep 2024

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc6 is released.

This is the sixth release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc6

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** New interfaces

***** New (g-golf support color) module

A color management module has been added. Documented under the Support
Canyon -> Color Hollow section.

***** Adding derived class custom layout-manager support

Derived class now support a #:layout-manager define-class option.

***** nil

Users need a way to inform g-golf to not process some callback ffi 'out
argument(s) (which can't be by using #f, as this mught be a valid ffi
'out arg value). To solve this, g-golf now defines a global nil variable
(defined as 'nil). See the newly added layout manager demo for a
concrete example of such a need and usage.

**** Examples

***** Gtk-4 - Layout Manager

The upstream gtk4-demo layout-manager (transition) example has been
ported to g-golf.

***** Adwaita Demo

The following Adwaita Demo pages have been added:

  AdwDemoPageButtons
  AdwDemoPageToasts
  AdwDemoPageBanners
  AdwDemoPageAbout

**** Bug fixing

***** <vfunc>

<vfunc> instances must hold a reference to the <closure-callback>
instance (not the <callback> instance).

***** next-vfunc

Fixed to retreive the vfunc pointer offset from one of the
class-direct-supers, recursively if needed, then grab and unlesss NULL,
call the immediate direct super vfunc.

***** g-golf-vfunc-closure

Enhanced to accept and (use if passed) an optional argument,
vfunc-long-name, as vfunc callback instances must be cached against
their long name, i.e. gdk-paintable-get-flags, gdk-paintable-snapshot
... (not get-flags, snapshot ...).

***** g-callable-info-make-closure

When calling g-callable-info-create-closure (fixed to work with the new
libffi api), we also need to call (and return the result of)
g-callable-info-get-closure-native-address, as the native-ptr.

***** ffi 'out arg values

scm->gi-argument has been enhanced to properly ignore ffi 'out args for
which the value is nil.

scm->gi-argument has been fixed, when that applies, to properly set the
(dereferenced) foreign (ffi 'out arg) pointer to its value.

***** g-object-import-with-supers

For some still misterious reason, when automatically importing an object
dependency, such as, for example, importing GtkApplication will trigger
the import of (among many others ofc) the GtkLayoutManager, unless we
call g-base-info-ref upon the info, those info maybe gc'ed.

Although this should actually never happen, as g-golf doesn't unref any
GIObjectInfo instances (but it did 'misteriously' happen), to be on the
safe side of things, g-golf (core) now calls g-base-info-ref upon the
result of calling g-object-info-get-parent.

** Jul 2024

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc.5 is released.

This is the fifth release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc.5

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** New interfaces

g-markup-escape-text
gi-import-by-name
  new #:allow-constant? optional keyword argument

GVariant
GVariantClass
GVariantType

The GLib Variant, VariantType and VariantClass typelib entries are now
imported. Testing has been so far somewhat limited, but for what it's
worth, the AdwDemoPageTabView, added in this release, defines and uses a
couple of g-variant-new-boolean based simple actions. However, they work
iif g-simple-action-new-stateful calls pass #f (NULL) as their
parameter-type arg, and therefore, (as stated by the upstream
documentation), none of the action activate callback ever receives a
valid g-variant arg value (it always is #f (NULL)). This needs further
investigation, but you may (and even may prefer to) implement an hold an
action state as/in a goops slot, i.e. in the (pages tab-view
tab-view-demo-page) module, the icon?, loading?, needs-attention?,
indicator? and muted? slots.

**** Enhancement

***** Template and ui sxml files support

Syntax highlighting support for the comments attribute has been added.

***** g-closure-marshal

(1) <closure> initialize method has been updated to not force the
#:return-type and #:param-types initialize keyword arguments, as as
GObject actually fills the GClosure structure with those (unless you are
testing <closure> and plan to call the invoke g-golf method).

(2) some GObject function/method GClosure arg(s) should preserve the
GValue pointer when calling the user scheme closure, instead of
extracting its value - for example, bind-property-full last two args
expect a BindingTransformFunc GClosure, for which it is essential to
preserve its second and third GValue arguments, as the user needs to
actually set either one, the other or both.

Note that wrt (2), there is no way to automatically detect which
argument(s) of a callback require(s) a GValue pointer preservation prior
to call the user scheme closure. Therefore, g-golf implements a (simple)
mechanism to handle those situations, but it has to be maintained
'manually' - if you come across a similar need, not being covered by the
existing implementation, let us know, we'll fix it. Those interested may
search and read both the preserve-g-value-ptr? procedure code as well as
the preceding comment, which briefly explains how it works, in the
(g-golf hl-api callable) module.

**** Examples

***** Adwaita Demo

The Adwaita demo has been restructured, and now properly support the
Dark Style desktop (or application) mode.

The following Adwaita Demo pages have been added:

  AdwDemoPageAvatar
  AdwDemoPageSplitViews
  AdwDemoPageTabView

**** Bug fixing

***** <gtype-instance> g-param slots initialization

It was a bug not to call g-inst-g-param-set-property, whether the
instance initialization was passed an init-kw arg or whether the
initialization has to use the p-spec default value - fixed.

***** gi-import-registered with-methods? default value

Removing the specialization default value for the with-methods? argument
when the namespace is part of the namespace import exception list.

The fix allows to automatically (gi) import GLib/GObject typelib
component(s) that are not part of the manually (ffi) defined subset,
such as the GVariant type, constructors and methods.

** May 2024

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc-4 is released.

This is the fourth release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc-4

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** Examples

***** Adwaita Demo

The following Adwaita Demo pages have been added:

  AdwDemoPageCarousel
  AdwDemoPageClamp
  AdwDemoPageLists
  AdwDemoPageViewSwitcher

** April 2024

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc-3 is released.

This is the third release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc-3

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** Dependencies

***** Adwaita examples

  Adw-1  >=  1.5.0

The adw1-demo has been updated, following upstream changes, so that most
of its demo pages now inherit and/or use the AdwDialog class, which is
available in Adwaita since 1.5.

**** Examples

***** Adwaita Demo

The 'Navigation View' and 'Style Classes' pages have been updated to
inherit and/or use the AdwDialog Class.

The 'Dialogs' page has been updated to use the AdwAlertDialog class. It
also has been enhanced to properly support the async-api model, and,
while running the alert dialog callback, to dismiss any previsouly added
'Toast' if any.

**** Bug fixing

***** Autotool chain

Changes has been made to support parallel installation as well as
cross-compilation.

***** Callback closure marshal(er)

The callback closure marshal(er) has been fixed to support callback with
'inout and 'out argument(s).

***** scm->gi-argument

Fixed to allow all GDestroyNotify callback functions to be nullable by
default.

** November 2023

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc-2 is released.

This is the second release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc-2

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** Examples

Adwaita Demo

The 'Dialogs' page has been added to the demo.

**** Bug fixing

emit
signal-emit

Fixed to properly handle 'object extra arg(s) type. Prior to this fix, a
call such (emit window 'add-toast toast), with window and toast being
goops proxy instances, would raise an exception, as the extra args
handler missed a proper dispatch clause and treatment for the 'object
arg type,

** October 2023

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-rc-1 is released.

This is the first release candidate of the upcoming 0.8.0 release, now
available for testing.

*** Noteworthy changes in 0.8.0-rc-1

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** New features

Derived class
GObject properties

Derived classes slot exposed as a gobject property now also support the
boolean, uint, float, double, flags, string, param and boxed types.

**** Examples

Adwaita Demo

The 'Style Classes' page has been added to the demo.

** September 2023

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-alpha-6 is released.

This is the sixth release of the upcoming 0.8.0 release, now available
for testing.

*** Noteworthy changes in 0.8.0-alpha-6

Here is a summary of the noteworthy changes in this release. See G-Golf
[[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** Dependencies

- Core dependencies

The guile-lib dependency has been removed from the core dependencies, as
it effectively is only required to run the test-suite.

- Test suite

The test-suite requires guile-lib >= 0.2.5
The test-suite no longer requires Clutter.

- Adwaita examples

  Adw-1  >=  1.4.0

The adw1-demo - which currently implements the main window, primary menu
and first two pages (wip) - has been updated to correspond to the latest
upstream version, which no longer uses the deprecated AdwLeaflet*
classes. Instead, it uses the AdwNavigationSplitView, AdwNavigationView
and AdwNavigationPage classes, available since 1.4.0.

**** New features

Derived class
GObject properties

  Derived classes slot exposed as a gobject property now also support
  the object type - Wip (supported type are now int, enum and object).

disconnect

New method, which calls the newly added g-signal-handler-disconnect
binding.

**** Examples

Adwaita Demo

The adw1-demo - which currently implements the main window, primary menu
and first two pages (wip) - has been updated to correspond to the latest
upstream version, which no longer uses the deprecated AdwLeaflet*
classes. Instead, it uses the AdwNavigationSplitView, AdwNavigationView
and AdwNavigationPage classes, available since 1.4.0.

**** Bug fixing

g-value-set-boxed

Was silently setting the g-value to #f for opaque boxed type, fixed.

connect
signal-connect

Now return the handler-id, needed to call disconnect.

** August 2023

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-a.5 is released.

This is the fifth release of the upcoming 0.8.0 release, now available
for testing.

*** Changes since 0.8.0-a.4

Here is a summary of the noteworthy changes since version 0.8.0-a.4. See
G-Golf [[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** Dependencies

  Glib-2.0     >= 2.73.0
  Gobject-2.0  >= 2.73.0

G-Golf requires GObject-Introspection >= 1.72.0. This actually imposes
Glib-2.0 >= 2.73.0, which itself imposes Gobject-2.0 >= 2.73.0

**** New features

Derived class
GObject properties and signals

  Derived classes now support a mechanism that allow users to expose
  slots as gobject properties and define new signals.

Templates

  This release adds support for templates, a mechanism and facilities
  exposed by GtkWidget to automate the procedure of creating composite
  widgets with GtkBuilder XML.

Template and GtkBuilder ui files
SXML support

	[ currently in the examples/adw-1/adw1-demo/ui directory ]

  sxml-ui.el

  Emacs users should import this file in their .emacs file.

  This is an attempt to provide both indentation and font-lock support,
  so ui files editing becomes a more pleasant exprerience. It is a first
  draft, better then nothing (much better imo), but suggestions to
  improve would be welcome.

  Makefile

  Offered as an example of the simplest possible way to convert all
  *.scm files of a directory to their corresponding *.ui files.

**** Examples

Adwaita Demo

A G-Golf port of the Adwaita 1 demo. This is a work in progress,
currently implementing the Adwaita 1 demo window, header bars,
primary-menu (the inspector, preferences and about actions and windows)
as well as the Welcome and Leaflet pages:

Note: Adwaita 1.4 (unavailable in distros at the time of this release)
deprecates the AdwLeaflet* classes, in favor of the AdwNavigationView
and AdwNavigationPage classes. We'll move the demo to use those when
Adwaita 1.4 becomes available in dostros.

**** Bug fixing

A few G-Golf core bugs have been fixed, but none that we could expose
here as 'user visible'. If you're nonetheless interested to find out
what progress we made on that front, search the git logs for 'Fixing'
or 'Bug fixing'.

The peg-solitaire example

An ABI change was made, by the Gtk team, in Gtk 4.10.0, to the
gtk-css-provider-load-from-data function second argument, wHich is no
longer defined as an array, but a utf8, and hence g-golf would fail,
when using Gtk 4.10.0, to detect, compute and supply the third argument,
which is the css string length - fixed.

** April 2023

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-a.4 is released.

This is the fourth release of the upcoming 0.8.0 release, now available
for testing.

*** Changes since 0.8.0-a.3

Here is a summary of the noteworthy changes since version 0.8.0-a.3. See
G-Golf [[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** New features

Next-vfunc

  This release adds full support for a next-vfunc mechanism - which is
  to the GObject virtual method system what the next-method concept and
  mechanism is to the GOOPS (compute applicable) method system.

**** Examples

Simple Paintable
Animated Paintable

  New examples. Please note that these examples requires
  [[https://www.nongnu.org/guile-cairo/][guile-cairo]]. They actually requires a patched version of guile-cairo
  that contains the following new interface (which is not in guile-cairo
  1.11.2):

	cairo-pointer->context

**** Bug fixing

Missing <gobject> g-struct-fields

  At (load eval) time, the (g-golf defined) <gobject> class must be
  completed: retreive the class-struct and fill the <gobject>
  g-struct-fields slot - used by the vfunc mechanism.

** February 2023

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-a.3 is released.

This is the third release of the upcoming 0.8.0 release, now available
for testing.

*** Changes since 0.8.0-a.2

Here is a summary of the noteworthy changes since version 0.8.0-a.2. See
G-Golf [[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** Enhancement

Skip Array Length Argument(s)

This release implements skip array-length argument mechanism. This
affects all functions and methods of any upstream (type)lib that accept
one or more array argument(s), for which the function or method also
expect an array length argument.

Starting with this release, users don't have to pass those array length
arg(s) (more accurately, users may not pass those arg(s) anymore), as
G-Golf will supply those automatically. Note that this is also valid for
arrays of uint8 - those arg(s) are 'array of chars', that users must
provide as a string (as opposed to a list) - for example, see the
peg-solitaire example, updated accordingly, so that the
gtk-css-provider-load-from-data call does no longer provide the 'data'
array length argument.

**** Examples

All

Updated, wrt the above enhancement, to call the g-application-run method
'without' the args length argument.

Peg Solitaire

In addition, updating the call to gtk-css-provider-load-from-data,
removing the 'data' array length argument.

**** Bug fixing

Callback and VFunc

In G-Golf, both Callback and VFunc use one (identical) marshal
procedure, g-golf-callback-closure-marshal, entirely written in scheme,
which implements, in short, the foreign function interface (ffi) arg
retrieval and transfornmation into their scheme representation, then
call the callback of vfunc (user provided) scheme code, then sets the GI
argument to the return value (if any).

To obtain the ffi arg scheme representation values, G-Golf was calling
gi-type-info-extract-ffi-return-value (a GI function, in the girffi
module, not a G-Golf procedure) - but that function has some bug.

G-Golf has now been updated so g-golf-callback-closure-marshal calls a
'self made' ffi-args->scm (see commit 6a30a12dd) for further details on
this).

Peg Solitaire

The peg-solitaire example has been updated, as the Callback and VFunc
bug fixed its snapshot-vfunc method. More specifically its width and
height argument values are now correct, we no longer need to explicitly
call get-intrinsic-width and get-intrinsic-height.

** January 2023

[[http://www.gnu.org/software/g-golf][GNU G-Golf]] version 0.8.0-a.2 is released.

This is the second release of the upcoming 0.8.0 release, now available
for testing.

*** Changes since 0.8.0-a.1

Here is a summary of the noteworthy changes since version 0.8.0-a.1. See
G-Golf [[http://git.savannah.gnu.org/cgit/g-golf.git][git summary]] and [[http://git.savannah.gnu.org/cgit/g-golf.git/log/][git log]] for a complete list and description.

**** Dependencies

GObject-Introspection-1.0 >= 1.72.0

G-Golf uses GI girffi innterfaces, some only available since 1.72.0.

**** New interfaces

allocate-c-struct

**** Examples

Peg Solitaire

The peg snapshots (which are what users drag while playing the game) now
also have rounded corners. Before this improvment, they were being
clipped by their <gtk-image> instance hosts, which use both a css
border-radius style option and the overflow property, but users were
dragging a squared rectangle snapshot.

Drawing Widget

New example, which demonstrates how implement a widget that does some
custom drawing.

**** Performance

~15% improvement

  Note: by performance, until otherwise specified, we only refer to and
  measure how fast G-Golf imports the entire Gtk 4.0 typelib.

After some changes made to the G-Golf main GI cache, importing Gtk-4.0
shows a ~15% improvement.

**** Bug fixing

VFunc

A VFunc specializer may also be a g-object class, as the newly added
example demonstrates. Prior to this fix, a VFunc specializer was assumed
to (always) be a g-interface class (as in the peg-solitaire example).

GObject.TypeInstance

GObject.TypeInstance fundamental class support fix. They must inherit
<gtype-instance> and specify <gtype-class> as their metaclass.

** For older News, see [[http://www.gnu.org/software/g-golf/news.html][here]].
